TITLE Freehafer's file size program		; 
;........................................................................
msg	MACRO	msgout				; 
	mov AH, 09h					; function 09h
	lea DX, msgout				; DX holds message
	int 21h 					; display string interupt
ENDM							; 
;........................................................................
.MODEL small					; directive placing all memory in one segment
.586							; 
.stack 100h						; 
;........................................................................
.data							; 
	CW			DB 0Ah, 0Dh, "     Freehafer's Get File Size Program Is finished!", 0Ah, 0Dh, "     (C)2001 INNIEA PUBLISHING COMPANY, R", 153, 142, "k NOG!", 0Ah, 0Dh, '$'
	Message		DB "!", 0Ah, 0Dh, 0Ah, 0Dh, "     The size of the file, in bytes, is ", '$'
	EXITmsg		DB 0Ah, 0Dh, 0Ah, 0Dh, "     Program is terminated!", 0Ah, 0Dh,'$'     
	FileHandle		DW ?			; 
	FILE_SIZE		DD ?			; 
	Enterf		DB 0Ah, 0Dh, "     Enter the DOS path of the file you wish to get the size of!",0Dh,0Ah,0Ah,0Dh,"     Hit enter without inputting a file path to exit!",0Ah,0Dh,0Dh,0Ah,"     ~ ~ ~ ",'$'
	FileSZ  		DB "     The file you want the size of is:     ", '$'
	FSInput		DB 60			; 
	FSLengthInput	DB 0			; 
	pathFS		DB 60 dup ('$')	; 
;........................................................................
.code							; 
start:						; begin algorithm
;........................................................................
;							; move data segment into DS
;........................................................................
	mov AX, @data				; base address
	mov DS, AX					; of data segment
;........................................................................
;							; clear screen
;........................................................................
	mov AH, 2					; function number
	mov BH, 0					; video page
	mov DX, 0					; top left corner
	int 10h					; interrupt call
;........................................................................
;							; dark turqois background with light black font
;........................................................................
	mov AH,9					; function number
	mov CX, 2000				; number of characters of output
	mov BL, 30h					; color code
	mov AL, " "					; blank characters
	int 10h					; call interrupt
doitagain:						; 
;........................................................................
;							; input path of file you wish to get the size of
;........................................................................
	msg Enterf					; input request for name of file to copy from
	mov AH, 0Ah					; input string function
	lea DX, FSInput				; DS:DX = address of input buffer
	int 21h					; call interrupt
	mov BL, FSLengthInput			; length of string actually read
	mov BH, 0					; high byte of length = 0 (length < 256)
	msg FileSZ					; display file path
	mov pathFS[BX], '$'			; make string displayable
	msg pathFS 					; display string
	mov pathFS[BX], 0				; make null terminated path
;........................................................................
	.IF (pathFS[BX - 1] == 0 || pathFS[BX - 1] == 32 || pathFS[BX - 1] == 255)
	jmp ender					; exit if no path entered
	.ENDIF					; 
;........................................................................
;							; open file
;........................................................................
	lea DX, pathFS				; DS:DX address of device name
	mov AL, 2					; access mode read write
	mov AH, 3Dh					; open  file function
	int 21h					; interrupt call
	mov FileHandle, AX			; store handle of device
;........................................................................
;							; get file size
;........................................................................
	mov CX, 0h					; CX:DX = distance to move from
	mov DX, 0h					;
	mov AH, 42h					; file pointer function
	mov AL, 2h					; (0 - Relative to beginning, 1 - current, 2 - end.)
	mov BX, FileHandle			; file handle
	int 21h					; call interrupt
	mov WORD PTR [FILE_SIZE], AX		; DX:AX
	mov WORD PTR [FILE_SIZE + 2], DX	; high order
;........................................................................
	msg Message					; 
;........................................................................
;							; output file size
;........................................................................
	push EAX					; values on stack
	push EBX					; values on stack
	push ECX					; values on stack
	push EDX					; values on stack
	mov EAX, FILE_SIZE			; number to be printed 
	mov EBX, 10					; base 10 divider
	mov ECX, 0					; 
H_D:							; 
	mov EDX, 0					; 
	div EBX					; divide command result is in
	push EDX					; push remainder onto stack
	inc ECX					; increase counter
	cmp EAX, 0					; check if result is zero and
	jne H_D					; 
	mov EAX, 200h				; function
OutSym: pop EDX					; 
	add DL, '0'					; 
	int 21h					; interrupt
	loop OutSym					; 
	pop EDX					; values off stack
	pop ECX					; values off stack
	pop EBX					; values off stack
	pop EAX					; values off stack
;........................................................................
;							; close file
;........................................................................
	mov BX, FileHandle			; handle to device
	mov ah, 3eh					; close file
	int 21h					; interrupt call
;........................................................................
	jmp doitagain				; 
ender:						; 
	msg EXITmsg					; 
	msg CW					; 
;........................................................................
;							; restore screen
;........................................................................
	mov AH,9					; function number
	mov CX, 2000				; number of characters of output
	mov BL, 0Fh					; color code
	mov AL, " "					; blank characters
	int 10h					; call interrupt
;........................................................................
	mov AX,4C00h				; 
	int 21h					; termination interupt
;........................................................................
end  start						; end program


